<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: MFLTFont Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="classes.html"><span>Data&nbsp;Structure&nbsp;Index</span></a></li>
      <li><a href="functions.html"><span>Data&nbsp;Fields</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>MFLTFont Struct Reference<br/>
<small>
[<a class="el" href="group__m17nFLT.html">FLT API</a>]</small>
</h1><!-- doxytag: class="MFLTFont" -->
<p>Type of font to be used by the FLT driver.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a4ee5ae21387ac0a308d325c2803ce38d">family</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a4f5da0ed80dcff1a9518f8ea538dc805">x_ppem</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#ad645f26ac88930e973a637163c4cfae3">y_ppem</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a0be91be8feeb8e0506011cb6a8794032">get_glyph_id</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a0c12c56b74101919f49cc396edb9c4fb">get_metrics</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#ab700eef1e5f6c36245e810192264c8c0">check_otf</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int(*&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a526e63af6e82feb162dba9b8ba1b7219">drive_otf</a> )(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *in, int from, int to, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *out, <a class="el" href="structMFLTGlyphAdjustment.html">MFLTGlyphAdjustment</a> *adjustment)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMFLTFont.html#a246902fe3b4b6a918a51daa05051a6ed">internal</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Type of font to be used by the FLT driver. </p>
<p>The type <a class="el" href="structMFLTFont.html" title="Type of font to be used by the FLT driver.">MFLTFont</a> is the structure that contains information about a font used by the FLT driver. Usually, an application should prepare a bigger structure whose first element is <a class="el" href="structMFLTFont.html" title="Type of font to be used by the FLT driver.">MFLTFont</a> and has more information about the font that is used by callback funcitons, and give that structure to mflt functions by coercing it to <a class="el" href="structMFLTFont.html" title="Type of font to be used by the FLT driver.">MFLTFont</a>. It is assured that callback functions can safely coerce <a class="el" href="structMFLTFont.html" title="Type of font to be used by the FLT driver.">MFLTFont</a> back to the original structure. </p>
<hr/><h2>Field Documentation</h2>
<a class="anchor" id="a4ee5ae21387ac0a308d325c2803ce38d"></a><!-- doxytag: member="MFLTFont::family" ref="a4ee5ae21387ac0a308d325c2803ce38d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="structMFLTFont.html#a4ee5ae21387ac0a308d325c2803ce38d">MFLTFont::family</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Family name of the font. It may be <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a> if the family name is not important in finding a Font Layout Table suitable for the font (for instance, in the case that the font is an OpenType font). </p>

</div>
</div>
<a class="anchor" id="a4f5da0ed80dcff1a9518f8ea538dc805"></a><!-- doxytag: member="MFLTFont::x_ppem" ref="a4f5da0ed80dcff1a9518f8ea538dc805" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMFLTFont.html#a4f5da0ed80dcff1a9518f8ea538dc805">MFLTFont::x_ppem</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Horizontal font sizes in pixels per EM. </p>

</div>
</div>
<a class="anchor" id="ad645f26ac88930e973a637163c4cfae3"></a><!-- doxytag: member="MFLTFont::y_ppem" ref="ad645f26ac88930e973a637163c4cfae3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMFLTFont.html#ad645f26ac88930e973a637163c4cfae3">MFLTFont::y_ppem</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Vertical font sizes in pixels per EM. </p>

</div>
</div>
<a class="anchor" id="a0be91be8feeb8e0506011cb6a8794032"></a><!-- doxytag: member="MFLTFont::get_glyph_id" ref="a0be91be8feeb8e0506011cb6a8794032" args=")(struct _MFLTFont *font, MFLTGlyphString *gstring, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a0be91be8feeb8e0506011cb6a8794032">MFLTFont::get_glyph_id</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Callback function to get glyph IDs for glyphs between FROM (inclusive) and TO (exclusive) of GSTRING. If the member &lt;encoded&gt; of a glyph is zero, the member &lt;code&gt; of that glyph is a character code. The function must convert it to the glyph ID of FONT. </p>

</div>
</div>
<a class="anchor" id="a0c12c56b74101919f49cc396edb9c4fb"></a><!-- doxytag: member="MFLTFont::get_metrics" ref="a0c12c56b74101919f49cc396edb9c4fb" args=")(struct _MFLTFont *font, MFLTGlyphString *gstring, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a0c12c56b74101919f49cc396edb9c4fb">MFLTFont::get_metrics</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *gstring, int from, int to)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Callback function to get metrics of glyphs between FROM (inclusive) and TO (exclusive) of GSTRING. If the member &lt;measured&gt; of a glyph is zero, the function must set the members &lt;xadv&gt;, &lt;yadv&gt;, &lt;ascent&gt;, &lt;descent&gt;, &lt;lbearing&gt;, and &lt;rbearing&gt; of the glyph. </p>

</div>
</div>
<a class="anchor" id="ab700eef1e5f6c36245e810192264c8c0"></a><!-- doxytag: member="MFLTFont::check_otf" ref="ab700eef1e5f6c36245e810192264c8c0" args=")(struct _MFLTFont *font, MFLTOtfSpec *spec)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#ab700eef1e5f6c36245e810192264c8c0">MFLTFont::check_otf</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Callback function to check if the font has OpenType GSUB/GPOS features for a specific script/language. The function must return 1, if the font satisfies SPEC, or 0. It must be NULL if the font does not have OpenType tables. </p>

</div>
</div>
<a class="anchor" id="a526e63af6e82feb162dba9b8ba1b7219"></a><!-- doxytag: member="MFLTFont::drive_otf" ref="a526e63af6e82feb162dba9b8ba1b7219" args=")(struct _MFLTFont *font, MFLTOtfSpec *spec, MFLTGlyphString *in, int from, int to, MFLTGlyphString *out, MFLTGlyphAdjustment *adjustment)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int(* <a class="el" href="structMFLTFont.html#a526e63af6e82feb162dba9b8ba1b7219">MFLTFont::drive_otf</a>)(struct _MFLTFont *font, <a class="el" href="structMFLTOtfSpec.html">MFLTOtfSpec</a> *spec, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *in, int from, int to, <a class="el" href="structMFLTGlyphString.html">MFLTGlyphString</a> *out, <a class="el" href="structMFLTGlyphAdjustment.html">MFLTGlyphAdjustment</a> *adjustment)</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Callback function to apply OpenType features in SPEC to glyphs between FROM (inclusive) and TO (exclusive) of IN. The resulting glyphs are appended to the tail of OUT. If OUT does not have a room to store all the resulting glyphs, it must return -2. It must be NULL if the font does not have OpenType tables. </p>

</div>
</div>
<a class="anchor" id="a246902fe3b4b6a918a51daa05051a6ed"></a><!-- doxytag: member="MFLTFont::internal" ref="a246902fe3b4b6a918a51daa05051a6ed" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMFLTFont.html#a246902fe3b4b6a918a51daa05051a6ed">MFLTFont::internal</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>For m17n-lib's internal use only. It should be initialized to NULL. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
